_UartReceiverInit:
;UartReceiver_P32.mpas,122 :: 		begin
;UartReceiver_P32.mpas,123 :: 		UartBuffWritePtr := 0;
SH	R0, Offset(UartReceiver_P32_UartBuffWritePtr+0)(GP)
;UartReceiver_P32.mpas,124 :: 		UartBuffReadPtr := 0;
SH	R0, Offset(UartReceiver_P32_UartBuffReadPtr+0)(GP)
;UartReceiver_P32.mpas,125 :: 		UartBufferEmpty := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(UartReceiver_P32_UartBufferEmpty+0)(GP)
;UartReceiver_P32.mpas,126 :: 		UartBufferFull := false;
SW	R0, Offset(UartReceiver_P32_UartBufferFull+0)(GP)
;UartReceiver_P32.mpas,127 :: 		UartBufferOverflow := false;
SW	R0, Offset(_UartBufferOverflow+0)(GP)
;UartReceiver_P32.mpas,128 :: 		OERR_bit := 0; // clear overrun error
LUI	R2, BitMask(OERR_bit+0)
ORI	R2, R2, BitMask(OERR_bit+0)
_SX	
;UartReceiver_P32.mpas,129 :: 		FERR_bit := 0; // clear framing error
LUI	R2, BitMask(FERR_bit+0)
ORI	R2, R2, BitMask(FERR_bit+0)
_SX	
;UartReceiver_P32.mpas,130 :: 		PERR_bit := 0; // clear parity error
LUI	R2, BitMask(PERR_bit+0)
ORI	R2, R2, BitMask(PERR_bit+0)
_SX	
;UartReceiver_P32.mpas,131 :: 		for I := 0 to 3 do Dummy := U1RxReg;   // clear Uart1 Fifo
; I start address is: 16 (R4)
MOVZ	R4, R0, R0
; I end address is: 16 (R4)
L__UartReceiverInit2:
; I start address is: 16 (R4)
ANDI	R3, R4, 255
ORI	R2, R0, 3
BNE	R3, R2, L__UartReceiverInit42
NOP	
J	L__UartReceiverInit5
NOP	
L__UartReceiverInit42:
ADDIU	R2, R4, 1
ANDI	R4, R2, 255
; I end address is: 16 (R4)
J	L__UartReceiverInit2
NOP	
L__UartReceiverInit5:
;UartReceiver_P32.mpas,132 :: 		U1RXIF_bit := 0;                       // clear interrupt received flag
LUI	R2, BitMask(U1RXIF_bit+0)
ORI	R2, R2, BitMask(U1RXIF_bit+0)
_SX	
;UartReceiver_P32.mpas,133 :: 		U1RXIE_bit := 1;                       // enable uart1 received interrupt
LUI	R2, BitMask(U1RXIE_bit+0)
ORI	R2, R2, BitMask(U1RXIE_bit+0)
_SX	
;UartReceiver_P32.mpas,134 :: 		end;
L_end_UartReceiverInit:
JR	RA
NOP	
; end of _UartReceiverInit
_UartCharPresent:
;UartReceiver_P32.mpas,137 :: 		begin
;UartReceiver_P32.mpas,138 :: 		Result := false;
; Result start address is: 12 (R3)
MOVZ	R3, R0, R0
;UartReceiver_P32.mpas,139 :: 		if (UartBufferEmpty = false)
LW	R2, Offset(UartReceiver_P32_UartBufferEmpty+0)(GP)
BEQ	R2, R0, L__UartCharPresent44
NOP	
J	L__UartCharPresent39
NOP	
L__UartCharPresent44:
; Result end address is: 12 (R3)
;UartReceiver_P32.mpas,142 :: 		Result := true;
; Result start address is: 8 (R2)
LUI	R2, 65535
ORI	R2, R2, 65535
; Result end address is: 8 (R2)
;UartReceiver_P32.mpas,143 :: 		end;
J	L__UartCharPresent8
NOP	
L__UartCharPresent39:
;UartReceiver_P32.mpas,139 :: 		if (UartBufferEmpty = false)
MOVZ	R2, R3, R0
;UartReceiver_P32.mpas,143 :: 		end;
L__UartCharPresent8:
;UartReceiver_P32.mpas,144 :: 		end;
; Result start address is: 8 (R2)
; Result end address is: 8 (R2)
L_end_UartCharPresent:
JR	RA
NOP	
; end of _UartCharPresent
_ReadUartByte:
;UartReceiver_P32.mpas,147 :: 		begin
ADDIU	SP, SP, -4
;UartReceiver_P32.mpas,148 :: 		U1RXIE_bit := 0;   // Disable Uart Interrupts
LUI	R2, BitMask(U1RXIE_bit+0)
ORI	R2, R2, BitMask(U1RXIE_bit+0)
_SX	
;UartReceiver_P32.mpas,149 :: 		if UartBufferEmpty = false then
LW	R2, Offset(UartReceiver_P32_UartBufferEmpty+0)(GP)
BEQ	R2, R0, L__ReadUartByte46
NOP	
J	L__ReadUartByte12
NOP	
L__ReadUartByte46:
;UartReceiver_P32.mpas,151 :: 		Result := UartBuffer[UartBuffReadPtr];
LHU	R3, Offset(UartReceiver_P32_UartBuffReadPtr+0)(GP)
LUI	R2, hi_addr(_UartBuffer+0)
ORI	R2, R2, lo_addr(_UartBuffer+0)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
SB	R2, 0(SP)
;UartReceiver_P32.mpas,152 :: 		Inc(UartBuffReadPtr);
LHU	R2, Offset(UartReceiver_P32_UartBuffReadPtr+0)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(UartReceiver_P32_UartBuffReadPtr+0)(GP)
;UartReceiver_P32.mpas,153 :: 		if UartBuffReadPtr = UartBuffSize then UartBuffReadPtr := 0;
ANDI	R3, R2, 65535
LUI	R2, _UartBuffSize+2
ORI	R2, R2, _UartBuffSize
BEQ	R3, R2, L__ReadUartByte47
NOP	
J	L__ReadUartByte15
NOP	
L__ReadUartByte47:
SH	R0, Offset(UartReceiver_P32_UartBuffReadPtr+0)(GP)
L__ReadUartByte15:
;UartReceiver_P32.mpas,154 :: 		UartBufferFull := false;
SW	R0, Offset(UartReceiver_P32_UartBufferFull+0)(GP)
;UartReceiver_P32.mpas,155 :: 		UartBufferEmpty := (UartBuffReadPtr = UartBuffWritePtr);
LHU	R3, Offset(UartReceiver_P32_UartBuffWritePtr+0)(GP)
LHU	R2, Offset(UartReceiver_P32_UartBuffReadPtr+0)(GP)
XOR	R2, R2, R3
SLTIU	R2, R2, 1
BEQ	R2, R0, L__ReadUartByte49
NOP	
ADDIU	R2, R0, -1
L__ReadUartByte49:
SW	R2, Offset(UartReceiver_P32_UartBufferEmpty+0)(GP)
;UartReceiver_P32.mpas,156 :: 		end;
L__ReadUartByte12:
;UartReceiver_P32.mpas,157 :: 		U1RXIE_bit := 1;  // Enable Uart Interrupts again
LUI	R2, BitMask(U1RXIE_bit+0)
ORI	R2, R2, BitMask(U1RXIE_bit+0)
_SX	
;UartReceiver_P32.mpas,158 :: 		end;
LBU	R2, 0(SP)
L_end_ReadUartByte:
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _ReadUartByte
_UartReceiverInterrupt:
;UartReceiver_P32.mpas,161 :: 		begin
;UartReceiver_P32.mpas,162 :: 		UartError := false;
SW	R0, Offset(UartReceiver_P32_UartError+0)(GP)
;UartReceiver_P32.mpas,164 :: 		if (U1STA and %1110) > 0 then // error
LW	R2, Offset(U1STA+0)(GP)
ANDI	R2, R2, 14
SLTIU	R2, R2, 1
BEQ	R2, R0, L__UartReceiverInterrupt51
NOP	
J	L__UartReceiverInterrupt19
NOP	
L__UartReceiverInterrupt51:
;UartReceiver_P32.mpas,166 :: 		if OERR_bit = 1 then OERR_bit := 0; // overrun error
_LX	
EXT	R2, R2, BitPos(OERR_bit+0), 1
BNE	R2, 1, L__UartReceiverInterrupt53
NOP	
J	L__UartReceiverInterrupt22
NOP	
L__UartReceiverInterrupt53:
LUI	R2, BitMask(OERR_bit+0)
ORI	R2, R2, BitMask(OERR_bit+0)
_SX	
L__UartReceiverInterrupt22:
;UartReceiver_P32.mpas,167 :: 		if FERR_bit = 1 then FERR_bit := 0; // framing error
_LX	
EXT	R2, R2, BitPos(FERR_bit+0), 1
BNE	R2, 1, L__UartReceiverInterrupt55
NOP	
J	L__UartReceiverInterrupt25
NOP	
L__UartReceiverInterrupt55:
LUI	R2, BitMask(FERR_bit+0)
ORI	R2, R2, BitMask(FERR_bit+0)
_SX	
L__UartReceiverInterrupt25:
;UartReceiver_P32.mpas,168 :: 		if PERR_bit = 1 then PERR_bit := 0; // parity error
_LX	
EXT	R2, R2, BitPos(PERR_bit+0), 1
BNE	R2, 1, L__UartReceiverInterrupt57
NOP	
J	L__UartReceiverInterrupt28
NOP	
L__UartReceiverInterrupt57:
LUI	R2, BitMask(PERR_bit+0)
ORI	R2, R2, BitMask(PERR_bit+0)
_SX	
L__UartReceiverInterrupt28:
;UartReceiver_P32.mpas,169 :: 		UartError := true;
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(UartReceiver_P32_UartError+0)(GP)
;UartReceiver_P32.mpas,170 :: 		end;
L__UartReceiverInterrupt19:
;UartReceiver_P32.mpas,172 :: 		UartData := U1RxReg; // get data
LW	R2, Offset(U1RXREG+0)(GP)
SB	R2, Offset(UartReceiver_P32_UartData+0)(GP)
;UartReceiver_P32.mpas,174 :: 		if UartError = false then
LW	R2, Offset(UartReceiver_P32_UartError+0)(GP)
BEQ	R2, R0, L__UartReceiverInterrupt58
NOP	
J	L__UartReceiverInterrupt31
NOP	
L__UartReceiverInterrupt58:
;UartReceiver_P32.mpas,176 :: 		if UartBufferFull = false then
LW	R2, Offset(UartReceiver_P32_UartBufferFull+0)(GP)
BEQ	R2, R0, L__UartReceiverInterrupt59
NOP	
J	L__UartReceiverInterrupt34
NOP	
L__UartReceiverInterrupt59:
;UartReceiver_P32.mpas,178 :: 		UartBuffer[UartBuffWritePtr] := UartData;
LHU	R3, Offset(UartReceiver_P32_UartBuffWritePtr+0)(GP)
LUI	R2, hi_addr(_UartBuffer+0)
ORI	R2, R2, lo_addr(_UartBuffer+0)
ADDU	R3, R2, R3
LBU	R2, Offset(UartReceiver_P32_UartData+0)(GP)
SB	R2, 0(R3)
;UartReceiver_P32.mpas,179 :: 		Inc(UartBuffWritePtr);
LHU	R2, Offset(UartReceiver_P32_UartBuffWritePtr+0)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(UartReceiver_P32_UartBuffWritePtr+0)(GP)
;UartReceiver_P32.mpas,180 :: 		if UartBuffWritePtr = UartBuffSize then UartBuffWritePtr := 0;
ANDI	R3, R2, 65535
LUI	R2, _UartBuffSize+2
ORI	R2, R2, _UartBuffSize
BEQ	R3, R2, L__UartReceiverInterrupt60
NOP	
J	L__UartReceiverInterrupt37
NOP	
L__UartReceiverInterrupt60:
SH	R0, Offset(UartReceiver_P32_UartBuffWritePtr+0)(GP)
L__UartReceiverInterrupt37:
;UartReceiver_P32.mpas,181 :: 		UartBufferEmpty := false;
SW	R0, Offset(UartReceiver_P32_UartBufferEmpty+0)(GP)
;UartReceiver_P32.mpas,182 :: 		UartBufferFull := (UartBuffWritePtr = UartBuffReadPtr);
LHU	R3, Offset(UartReceiver_P32_UartBuffReadPtr+0)(GP)
LHU	R2, Offset(UartReceiver_P32_UartBuffWritePtr+0)(GP)
XOR	R2, R2, R3
SLTIU	R2, R2, 1
BEQ	R2, R0, L__UartReceiverInterrupt62
NOP	
ADDIU	R2, R0, -1
L__UartReceiverInterrupt62:
SW	R2, Offset(UartReceiver_P32_UartBufferFull+0)(GP)
;UartReceiver_P32.mpas,183 :: 		end
J	L__UartReceiverInterrupt35
NOP	
;UartReceiver_P32.mpas,184 :: 		else UartBufferOverflow := true;
L__UartReceiverInterrupt34:
LUI	R2, 65535
ORI	R2, R2, 65535
SW	R2, Offset(_UartBufferOverflow+0)(GP)
L__UartReceiverInterrupt35:
;UartReceiver_P32.mpas,185 :: 		end;
L__UartReceiverInterrupt31:
;UartReceiver_P32.mpas,187 :: 		U1RXIF_bit := 0;
LUI	R2, BitMask(U1RXIF_bit+0)
ORI	R2, R2, BitMask(U1RXIF_bit+0)
_SX	
;UartReceiver_P32.mpas,188 :: 		end;
L_end_UartReceiverInterrupt:
JR	RA
NOP	
; end of _UartReceiverInterrupt
